开学了住校了打不了深夜场

好难受啊QwQ


A

显然对于每个起点,我们只需要贪心记录这个起点出发出去的糖果数量以及离自己最近的糖果

因为这个起点最后一次装载糖果一定是装载终点离自己最近的那个糖果

$ O(n^2)$暴力贪心即可

有线性做法懒得写了

#include<ctime>
#include<cmath>
#include<cstdio>
#include<cstring>
#include<iostream>
#include<algorithm>
#include<queue>
#include<vector>
#define rt register int
#define ll long long
using namespace std;
inline ll read(){
ll x=;char zf=;char ch=getchar();
while(ch!='-'&&!isdigit(ch))ch=getchar();
if(ch=='-')zf=-,ch=getchar();
while(isdigit(ch))x=x*+ch-'',ch=getchar();return x*zf;
}
void write(ll y){if(y<)putchar('-'),y=-y;if(y>)write(y/);putchar(y%+);}
void writeln(const ll y){write(y);putchar('\n');}
int k,m,n,x,y,z,cnt,ans;
int sum[],far[];
int main(){
n=read();m=read();
for(rt i=;i<=m;i++){
x=read();y=read();
sum[x]++;
if((y+n-x)%n<far[x]||sum[x]==)far[x]=(y+n-x)%n;
}
for(rt i=;i<=n;i++){
int ans=;
for(rt j=;j<=n;j++)ans=max(ans,(sum[j]-)*n+far[j]+(j+n-i)%n);
write(ans),putchar(' ');
}
return ;
}

B

构造题的做法很多样化

一开始写了一个乱七八糟的乱搞过了

然后看了眼标程提供的Answer顿感智商被碾压

我们只需要在最前面放一个$ -1$

后面放一段长度为$ len$,和为$ sum$的非负整数序列即可

则差值为$$(sum-1)(len+1)-sum·len=sum-len-1$$

随便拿个$ len$跑出来一组$sum$即可

我原先做法就不讲了

#include<ctime>
#include<cmath>
#include<cstdio>
#include<cstring>
#include<iostream>
#include<algorithm>
#include<queue>
#include<vector>
#define rt register int
#define ll long long
using namespace std;
inline ll read(){
ll x=;char zf=;char ch=getchar();
while(ch!='-'&&!isdigit(ch))ch=getchar();
if(ch=='-')zf=-,ch=getchar();
while(isdigit(ch))x=x*+ch-'',ch=getchar();return x*zf;
}
void write(ll y){if(y<)putchar('-'),y=-y;if(y>)write(y/);putchar(y%+);}
void writeln(const ll y){write(y);putchar('\n');}
int k,m,n,x,y,z,cnt,ans;
void pt(int x,int y){
for(rt i=;i<=y;i++)if(x<=)cout<<x<<' ',x=;
else cout<<<<' ',x-=;
}
int main(){
k=read();
int S=k+,L=;
cout<<L+<<endl;
cout<<-<<' ';pt(S,L);
return ;
}

C

每次的答案相当于上次的答案加上当前串所有后缀的贡献

那每次把当前串反向插入到$ trie$树中

如果有新建节点就利用这个点往上四层的四个祖先计算$ DP$值并加入答案

注意细节

我的$ trie$树奇丑无比不要模仿....

#include<ctime>
#include<cmath>
#include<cstdio>
#include<cstring>
#include<iostream>
#include<algorithm>
#include<queue>
#include<vector>
#define p 1000000007
#define rt register int
#define ll long long
using namespace std;
inline ll read(){
ll x=;char zf=;char ch=getchar();
while(ch!='-'&&!isdigit(ch))ch=getchar();
if(ch=='-')zf=-,ch=getchar();
while(isdigit(ch))x=x*+ch-'',ch=getchar();return x*zf;
}
void write(ll y){if(y<)putchar('-'),y=-y;if(y>)write(y/);putchar(y%+);}
void writeln(const ll y){write(y);putchar('\n');}
int k,m,n,x,y,z,cnt,ans,Root;
struct trie{
int son[],fa;
}a[];
int v[],dp[];
void insert(int &x,int pl){
if(!x)x=++cnt;if(pl==)return;
bool fla=;int val=;
if(!a[x].son[v[pl]])a[x].son[v[pl]]=++cnt;a[a[x].son[v[pl]]].fa=x;
if(!dp[a[x].son[v[pl]]]){
int now=x,zhi=;
for(rt i=;i<;i++){
if(!now)continue;
zhi|=(<<i)*(v[pl+i]);
if((zhi==||zhi==||zhi==||zhi==)&&i==)break;
(val+=dp[now])%=p;now=a[now].fa;
}
dp[a[x].son[v[pl]]]=val,(ans+=val)%=p;
}
insert(a[x].son[v[pl]],pl-);
}
int main(){
n=read();dp[]=;
for(rt i=;i<=n;i++){
v[i]=read();z=i;
insert(Root,i);
writeln(ans);
}
return ;
}

D

考虑构造一个新数组v

每当新在末尾增加一个数$a_i$的时候,把$ v_i$设置成1,把上一个值和$ a_i$相同的位置的v改成-1,把上上个值和$ a_i$相同的位置的v改成0

这么做的意义是$ \sum\limits_{j=L}^i v_j$恰好表示了这个后缀中只出现一次的数的数量

则有$ DP$方程:$$ dp_i=\sum_{j=0}^{i-1}dp_j[\sum_{d=j+1}^i v_d \leq k]$$

设$ S_i$表示$ \sum\limits_{j=1}^i v_j$

则有$ DP$方程:$$ dp_i=\sum_{j=1}^{i-1}dp_j(S_j\geq S_i-k)$$

每次求$ dp_i$的时候$ S_i$均可看成一个常数

因此每次相当于求所有$ S_j$不超过某个值的$ dp_j$之和

考虑分块

$ f_{x,y}$表示第$ x$个块,所有$ S$值不超过$ y$的$ dp$值之和

每次对$ S$修改的时候整块的在上面打标记,非整块暴力重构即可

时空复杂度均为$ O(n \sqrt{n})$

代码中为了方便将数组从$ 0$开始编号,与上面略有不同,请稍加注意

#include<ctime>
#include<cmath>
#include<cstdio>
#include<cstring>
#include<iostream>
#include<algorithm>
#include<queue>
#include<vector>
#define p 998244353
#define rt register int
#define ll long long
using namespace std;
inline ll read(){
ll x=;char zf=;char ch=getchar();
while(ch!='-'&&!isdigit(ch))ch=getchar();
if(ch=='-')zf=-,ch=getchar();
while(isdigit(ch))x=x*+ch-'',ch=getchar();return x*zf;
}
void write(ll y){if(y<)putchar('-'),y=-y;if(y>)write(y/);putchar(y%+);}
void writeln(const ll y){write(y);putchar('\n');}
int k,m,n,x,y,z,cnt,ans;
int la[],now[],v[],s[],dp[];
int f[][],tag[],blo,maxs[],id[];
void build(int x){
int Min=,Max=-;
for(rt i=x*blo;i<(x+)*blo;i++){
if(s[i]<Min)Min=s[i];
if(s[i]>Max)Max=s[i];
}
maxs[x]=Max-Min;
for(rt i=;i<=maxs[x];i++)f[x][i]=;
tag[x]+=Min;
for(rt i=x*blo;i<(x+)*blo;i++)s[i]-=Min,(f[x][s[i]]+=dp[i])%=p;
for(rt i=;i<=Max-Min;i++)(f[x][i]+=f[x][i-])%=p; }
void change(int L,int val,int R){
if(val==v[L])return;
int upd=val-v[L];v[L]=val;
if(id[L]==id[R]){
for(rt i=L;i<=R;i++)s[i]+=upd;
return;
}
for(rt i=L;i<(id[L]+)*blo;i++)s[i]+=upd;build(id[L]);
for(rt i=id[L]+;;i++){
if(i==id[R]){
for(rt j=i*blo;j<=R;j++)s[j]+=upd;
return;
}
tag[i]+=upd;
}
} int query(int x,int val){
//块x中大于等于val的值
val-=tag[x];
if(val>maxs[x])return ;
if(val<=)return f[x][maxs[x]];
return (f[x][maxs[x]]-f[x][val-])%p;
}
int main(){
n=read();k=read();blo=(int)sqrt(n);
for(rt i=;i<n;i++)id[i]=i/blo;
for(rt i=;i<=n;i++)now[i]=la[i]=-;
for(rt i=;i<n;i++){
x=read();if(i)s[i]=s[i-]+tag[(i-)/blo];
if(now[x]!=-)change(now[x],-,i);
if(la[x]!=-)change(la[x],,i);
la[x]=now[x];now[x]=i;v[i]=;s[i]++;
for(rt j=;j<=i;j+=blo)(dp[i]+=query(id[j],s[i]+tag[id[i]]-k))%=p;
for(rt j=i/blo*blo;j<i;j++)if(s[j]+tag[id[j]]>=s[i]+tag[id[i]]-k)(dp[i]+=dp[j])%=p;
if(s[i]<=k)dp[i]++;
if((i+)%blo==)build(id[i]);
}
cout<<(dp[n-]%p+p)%p;
return ;
}

E

很有趣的构造题

钦定一号点为根

首先用$ n-1$次询问得出每个点的$ size$大小

显然$ size$小的点不可能成为$ size$大的点的父亲

按$ size$排序,并按$ size$从小到大判断每个点的孩子编号

思路是将当前所有$ size$比自己小且不是任何点的孩子的节点排成一行

用一个集合维护所有不是任何点的孩子的节点

每次二分找出最靠左的那一个是自己孩子的节点,并将其从集合中删除

最后把自己加入集合即可

复杂度是每个点的孩子数·$\log$即$ O(n·\log n)$的

#include<ctime>
#include<cmath>
#include<cstdio>
#include<cstring>
#include<iostream>
#include<algorithm>
#include<queue>
#include<vector>
#include<set>
#define flush fflush(stdout)
#define rt register int
#define ll long long
using namespace std;
inline ll read(){
ll x=;char zf=;char ch=getchar();
while(ch!='-'&&!isdigit(ch))ch=getchar();
if(ch=='-')zf=-,ch=getchar();
while(isdigit(ch))x=x*+ch-'',ch=getchar();return x*zf;
}
void write(ll y){if(y<)putchar('-'),y=-y;if(y>)write(y/);putchar(y%+);}
void writeln(const ll y){write(y);putchar('\n');}
int k,m,n,x,y,z,cnt,ans;
int size[];
struct node{
int x,size;
bool operator <(const node s)const{
return size<s.size;
}
}a[];
int q[],t;
set<int>s;
int erase[],fa[],top;
bool chk(int L,int R,int nd){
writeln();writeln();
writeln(R-L+);
for(rt i=L;i<=R;i++)write(q[i]),putchar(' ');putchar('\n');
writeln(nd);flush;
return read();
}
int main(){
n=read();size[]=n;
for(rt i=;i<=n;i++){
writeln();
writeln();
writeln(n-);
for(rt j=;j<=n;j++)write(j),putchar(' ');putchar('\n');
writeln(i);flush;
size[i]=read();
}
for(rt i=;i<=n;i++)a[i]={i,size[i]};
sort(a+,a+n+);
for(rt i=;i<=n;i++){
t=;
for(auto i:s)q[++t]=i;
for(rt lef=;lef<=t;){
if(!chk(lef,t,a[i].x))break;
int L=lef,R=t,ans=;
while(L<=R){
const int mid=L+R>>;
if(chk(L,mid,a[i].x))ans=mid,R=mid-;
else L=mid+;
}
lef=ans+;fa[q[ans]]=a[i].x;erase[++top]=q[ans];
}
for(rt i=top;i>=;i--)s.erase(erase[i]);top=;
s.insert(a[i].x);
}
puts("ANSWER");
for(rt i=;i<=n;i++)write(fa[i]),putchar(' '),writeln(i);flush;
return ;
}

Codeforces Round #542 (Div. 1) 题解的更多相关文章

  1. Codeforces Round #182 (Div. 1)题解【ABCD】

    Codeforces Round #182 (Div. 1)题解 A题:Yaroslav and Sequence1 题意: 给你\(2*n+1\)个元素,你每次可以进行无数种操作,每次操作必须选择其 ...

  2. Codeforces Round 542 (Div. 2)

    layout: post title: Codeforces Round 542 (Div. 2) author: "luowentaoaa" catalog: true tags ...

  3. Codeforces Round #608 (Div. 2) 题解

    目录 Codeforces Round #608 (Div. 2) 题解 前言 A. Suits 题意 做法 程序 B. Blocks 题意 做法 程序 C. Shawarma Tent 题意 做法 ...

  4. Codeforces Round #525 (Div. 2)题解

    Codeforces Round #525 (Div. 2)题解 题解 CF1088A [Ehab and another construction problem] 依据题意枚举即可 # inclu ...

  5. Codeforces Round #528 (Div. 2)题解

    Codeforces Round #528 (Div. 2)题解 A. Right-Left Cipher 很明显这道题按题意逆序解码即可 Code: # include <bits/stdc+ ...

  6. Codeforces Round #466 (Div. 2) 题解940A 940B 940C 940D 940E 940F

    Codeforces Round #466 (Div. 2) 题解 A.Points on the line 题目大意: 给你一个数列,定义数列的权值为最大值减去最小值,问最少删除几个数,使得数列的权 ...

  7. Codeforces Round #677 (Div. 3) 题解

    Codeforces Round #677 (Div. 3) 题解 A. Boring Apartments 题目 题解 简单签到题,直接数,小于这个数的\(+10\). 代码 #include &l ...

  8. Codeforces Round #665 (Div. 2) 题解

    Codeforces Round #665 (Div. 2) 题解 写得有点晚了,估计都官方题解看完切掉了,没人看我的了qaq. 目录 Codeforces Round #665 (Div. 2) 题 ...

  9. Codeforces Round #160 (Div. 1) 题解【ABCD】

    Codeforces Round #160 (Div. 1) A - Maxim and Discounts 题意 给你n个折扣,m个物品,每个折扣都可以使用无限次,每次你使用第i个折扣的时候,你必须 ...

随机推荐

  1. UOJ #449. 【集训队作业2018】喂鸽子

    UOJ #449. [集训队作业2018]喂鸽子 小Z是养鸽子的人.一天,小Z给鸽子们喂玉米吃.一共有n只鸽子,小Z每秒会等概率选择一只鸽子并给他一粒玉米.一只鸽子饱了当且仅当它吃了的玉米粒数量\(≥ ...

  2. Vue 2.6版本基础知识概要(一)

    挂载组件 //将 App组件挂载到div#app节点里 new Vue({ render: h => h(App), }).$mount('#app') VueComponent.$mount ...

  3. VMware 安装 centos6.8

    参考文档:https://jingyan.baidu.com/article/49711c61964328fa441b7c93.html 准备工作 VMware Workstation Pro 下载地 ...

  4. 新人大餐:2018最新Office插件开发之ExcelDNA开发XLL插件免费教学视频,五分钟包教包会

    原始链接:https://www.cnblogs.com/Charltsing/p/ExcelDnaVideoCourse.html QQ: 564955427 先解释一下,为什么要做这个视频: 我在 ...

  5. Visual Studio Code扩展:

    Auto Close TagAuto Rename TagBeautifyChinese (Simplified) Language Pack for Visual Studio CodeClass ...

  6. 使用FindBugs寻找bug,代码分析

    安装就不说了,网上很多. 一些常见的错误信息 Bad practice 代码中的一些坏习惯 Class names should start with an upper case letter 主要包 ...

  7. springmvc的前端控制器

    <servlet> <servlet-name>xxx</servlet-name> <servlet-class>org.springframewor ...

  8. Bitmap的使用习惯——及时释放Bitmap占用的内存

    当Bitmap不再需要使用时,我们应该回收它占用的内存,如果我们直接把指向bitmap的引用置null的话,这样bitmap还是会存在内存中,直到GC机制起作用时,才可能会把这个bitmap回收.这样 ...

  9. 转载泡泡机器人——IMU预积分总结与公式推导2

    本文为IMU预积分总结与公式推导系列技术报告的第二篇. 承接第一篇的内容,本篇将推导IMU预积分的测量值,并分析其测量误差的分布形式. 传统捷联惯性导航的递推算法,以初始状态为基础,利用IMU测量得到 ...

  10. ASP.Net笔记整理(一)

    验证码类 using System; using System.Collections.Generic; using System.Drawing; using System.Drawing.Draw ...